//+------------------------------------------------------------------+
//|                                              3MA_fxtrades_ru.mq4 |
//|                                                      fxtrades.ru |
//|                                               http://fxtrades.ru |
//+------------------------------------------------------------------+
#property copyright "fxtrades.ru"
#property link      "http://fxtrades.ru"

#define magic 2342002

//---- input parameters
extern double    lots=0.1;
extern int       fast_ma_period=10;
extern int       medium_ma_period=25;
extern int       slow_ma_period=50;
extern int       ma_method=0;
extern int       applied_price=0;
extern int       close_variant = 2;
extern int       take_profit=0;
extern int       stop_loss=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
bool can_buy = false, can_sell = false;
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   double fma_prev=double iMA( Symbol(), 0, fast_ma_period, 0, ma_method, applied_price, 2);
   double fma_next=double iMA( Symbol(), 0, fast_ma_period, 0, ma_method, applied_price, 1);
   
   double mma_prev=double iMA( Symbol(), 0, medium_ma_period, 0, ma_method, applied_price, 2);
   double mma_next=double iMA( Symbol(), 0, medium_ma_period, 0, ma_method, applied_price, 1);
   
   double sma_prev=double iMA( Symbol(), 0, slow_ma_period, 0, ma_method, applied_price, 2);
   double sma_next=double iMA( Symbol(), 0, slow_ma_period, 0, ma_method, applied_price, 1);
   
//----
   int i;
   int err;
   
   //     
   if (close_variant == 1 || close_variant == 0)
   {
      // SELL orders
      if (fma_prev<=sma_prev && fma_next>sma_next && ChekForOrders(OP_SELL) > 0)
      {      
         for(i=0;i<OrdersTotal();i++)
         {
      
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
              if ( OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==magic)
                 if (OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)==false) 
                 {
                     //   
                     err=GetLastError();
                     Print("OrderSend failed with error #",err);        
                 }     
         }  
      }
      // BUY orders
      if (fma_prev>=sma_prev && fma_next<sma_next && fma_next<mma_next && ChekForOrders(OP_SELL)==0)
      {      
         for(i=0;i<OrdersTotal();i++)
         {
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
              if ( OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==magic)
                 if (OrderClose(OrderTicket(),OrderLots(),Bid,0,Red)==false) 
                 {
                     //   
                     err=GetLastError();
                     Print("OrderSend failed with error #",err);        
                 }  
         }   
      }  
   }

   //     
   if (close_variant == 2 || close_variant == 0)
   {
      // SELL orders
      if (fma_prev<=mma_prev && fma_next>mma_next && ChekForOrders(OP_SELL) > 0)
      {      
         for(i=0;i<OrdersTotal();i++)
         {
      
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
              if ( OrderSymbol()==Symbol() && OrderType()==OP_SELL && OrderMagicNumber()==magic)
                 if (OrderClose(OrderTicket(),OrderLots(),Ask,0,Red)==false) 
                 {
                     //   
                     err=GetLastError();
                     Print("OrderSend failed with error #",err);        
                 }     
         }  
      }
      // BUY orders
      if (fma_prev>=mma_prev && fma_next<mma_next && ChekForOrders(OP_SELL)==0)
      {      
         for(i=0;i<OrdersTotal();i++)
         {
            if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
              if ( OrderSymbol()==Symbol() && OrderType()==OP_BUY && OrderMagicNumber()==magic)
                 if (OrderClose(OrderTicket(),OrderLots(),Bid,0,Red)==false) 
                 {
                     //   
                     err=GetLastError();
                     Print("OrderSend failed with error #",err);        
                 }  
         }   
      }  
   }

   //    
   if (fma_next > sma_next && fma_next > mma_next)
      can_sell = true;
   
   if (fma_next < sma_next && fma_next < mma_next)
      can_buy = true;

   //       BUY 
   if ((fma_prev<=sma_prev || fma_prev<=mma_prev) && fma_next>sma_next && fma_next>mma_next && ChekForOrders(OP_BUY)==0 && can_buy)
   {    
      // buy
      OrderSendFunc(OP_SELL); // !!!   OP_BUY   OP_SELL
      can_buy = false;
   }
 
    //     
   if ((fma_prev>=sma_prev || fma_prev>=mma_prev) && fma_next<sma_next && fma_next<mma_next && ChekForOrders(OP_SELL)==0 && can_sell)
   {      
      // SELL
      OrderSendFunc(OP_BUY); // !!!   OP_SELL   OP_BUY
      can_sell = false;
   }  
   
   return(0);
  }
//+------------------------------------------------------------------+


//   cmd
int OrderSendFunc(int cmd)
  {
  if (cmd==OP_BUY) double Price=Ask;
  else Price=Bid;
  int ticket=OrderSend(Symbol(),cmd,lots,Price,0,GetSL(cmd),GetTP(cmd),NULL,magic,0,Blue);
  if(ticket<0)
    {
    int err=GetLastError();
    if (err==135)
      {
      //  " "     
      RefreshRates();
      ticket=OrderSend(Symbol(),cmd,lots,Price,0,GetSL(cmd),GetTP(cmd),NULL,magic,0,Blue);
      if (ticket<0) 
        {        
        err=GetLastError();
        Print("OrderSend failed with error #",err);
        }
      else Print("OrderSend failed with error #",err);
      return(-1);
      } 
    }
  return(ticket);
  }
  
  
//       StopLoss.
// Buy Order: cmd=OP_BUY,  Sell: cmd=OP_SELL      
double GetSL(int cmd)
  {
  if (stop_loss==0) return(0);
  else
    if (cmd==OP_BUY) return(Bid-stop_loss*Point);
    else return(Ask+stop_loss*Point);
  }
  
//       TakeProfit.
// Buy Order: cmd=OP_BUY,  Sell: cmd=OP_SELL   
double GetTP(int cmd)
  {
  if (take_profit==0) return(0);
  else
    if (cmd==OP_BUY) return(Ask+take_profit*Point);  
    else return(Bid-take_profit*Point);
  }
  
  
  //*     cmd*  
int ChekForOrders(int cmd)
   {
   int count=0;
   for(int i=0;i<OrdersTotal();i++)
         {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
           if (OrderSymbol()==Symbol() && OrderType()==cmd && OrderMagicNumber()==magic)
              count++;
         }
   return(count);
   }